# FineTuing工具使用说明

作者：康家琦
时间：2025年1月9日

该程序用于调整和更新AVS（全景视频拼接）参数，并且可以实时通过web或者VLC完成查看微调结果。以下是使用说明：

~~~ad-info
注意：本文档仅适用于AVS FineTuningTool程序.
当前程序仅适用于CD3403芯片作为微处理器，且使用拼接通道0，通道内pipe数量为4的情况。
该情况可以通过查看指定调试信息查看
cat /proc/umap/avs
~~~

## 确保已经把程序目录下的文件准备完毕

需要一个文件夹./calibration/，里面包含了cal文件，通过PQtool生成，生成的详细方法查看《嵌入式标定流程一览》。
当前的cal文件仅支持一种名称：4eye_2688x1520.cal，如果名称与之不一致会导致无法正常使用.

如果出现了提示无权限的情况，可以通过以下命令解决：
```sh
chmod +x ./avsFineTuningTool 
```

## 运行

运行程序时需要提供以下参数：

```sh
./avsFineTuningTool -INDEX <value> -YAW <value> -PITCH <value> -ROLL <value> -OFFSETX <value> -OFFSETY <value> -DISTANCE <value> -PATH <value>
```

### 参数说明

- `-INDEX <value>`: 设置索引值。
- `-YAW <value>`: 设置偏航角度。
- `-PITCH <value>`: 设置俯仰角度。
- `-ROLL <value>`: 设置滚转角度。
- `-OFFSETX <value>`: 设置X轴偏移量，需要注意的是某些情况下图像是经过倒放后进行投影的，需要考虑offsetx和offsety的转换。
- `-OFFSETY <value>`: 设置Y轴偏移量。
- `-DISTANCE <value>`: 设置拼接距离，值必须在0.5到10000之间。
- `-PATH <value>`: 设置保存路径,保存index对应的LUT文件到指定路径，如果没有路径，则会保存到当前目录下。

### 示例

```sh
./avsFineTuningTool -INDEX 1 -YAW 10.5 -PITCH 5.2 -ROLL 3.1 -OFFSETX 0.5 -OFFSETY 0.3 -DISTANCE 100 -PATH /path/to/save
```

### 注意事项

- 确保所有参数都已正确提供，否则程序将输出错误信息并退出。
- `-INDEX` 必须存在，用以指定需要生成的LUT文件, 参数的值必须在0到3之间。
- `-DISTANCE` 参数的值必须在0.5到10000之间，否则程序将输出错误信息并退出。
- 提供的参数值必须是整数，在后台会*100。
- 最少提供一个INDEX加上任意一个参数，否则程序将输出错误信息并退出。

## 功能

程序将根据提供的参数进行以下操作：

1. 设置拼接距离。
2. 设置索引对应的偏航、俯仰和滚转角度。
3. 设置索引对应的X轴和Y轴偏移量。
4. 设置AVSP LUT保存路径。
5. 生成LUT文件。
6. 更新组属性。

可以查看程序输出信息，以确认是否成功生成LUT文件。
