#include "avsUpdateTuning.hpp"
#include <iostream>


void AvsUpdateTuning::readLutFile(int index,std::string path, hi_u32 length, hi_u64 lut_output_addr[])
{
    FILE *fp;
    hi_s32 readByte = 0;

    std::string curPath;
    curPath = path + AVSP_LUT_NAME + std::to_string(index) + ".bin";

    fp = fopen(curPath.c_str(), "rb");
    if(fp == NULL) {
        printf("open file %s failed\n", curPath.c_str());
        return;
    }

    // address of the LUT offset 
    hi_u64 readAddr= lut_output_addr[index];

    readByte = fread((hi_char*)readAddr, 1, length, fp);

    if(readByte != length) {
        printf("read file failed\n");
        fclose(fp);
        return;
    }

    fclose(fp);

    return;
    
}

hi_s32 AvsUpdateTuning::updateGrpAttr()
{
    hi_s32 ret = 0;

    readLutFile(0,m_strPath,OT_AVS_LUT_SIZE,m_LutArray);
    readLutFile(1,m_strPath,OT_AVS_LUT_SIZE,m_LutArray);
    readLutFile(2,m_strPath,OT_AVS_LUT_SIZE,m_LutArray);
    readLutFile(3,m_strPath,OT_AVS_LUT_SIZE,m_LutArray);
    
    for(int i = 0; i < m_avs_pipe_num; i++) {
        m_avs_grp_attr.lut.phys_addr[i] = m_avs_lut_addr + i * OT_AVS_LUT_SIZE;
    }

    ret = hi_mpi_avs_set_grp_attr(m_avs_grp_index, &m_avs_grp_attr);
    if(ret != HI_SUCCESS) {
        return HI_FAILURE;
    }

    std::cout << "Update LUT address done" << std::endl;

    return HI_SUCCESS;
}
